Add hroller design to Makefile and design-drafts
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
27 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
28 CHECK_VERSION = $(top_srcdir)/autotools/check-version
29 CHECK_NEWS = $(top_srcdir)/autotools/check-news
30 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
31 DOCPP = $(top_srcdir)/autotools/docpp
32 REPLACE_VARS_SED = autotools/replace_vars.sed
33 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
34 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
35 SHELL_ENV_INIT = autotools/shell-env-init
36
37 # Note: these are automake-specific variables, and must be named after
38 # the directory + 'dir' suffix
39 clientdir = $(pkgpythondir)/client
40 hypervisordir = $(pkgpythondir)/hypervisor
41 httpdir = $(pkgpythondir)/http
42 masterddir = $(pkgpythondir)/masterd
43 confddir = $(pkgpythondir)/confd
44 rapidir = $(pkgpythondir)/rapi
45 serverdir = $(pkgpythondir)/server
46 watcherdir = $(pkgpythondir)/watcher
47 impexpddir = $(pkgpythondir)/impexpd
48 utilsdir = $(pkgpythondir)/utils
49 toolsdir = $(pkglibdir)/tools
50 iallocatorsdir = $(pkglibdir)/iallocators
51 pytoolsdir = $(pkgpythondir)/tools
52 docdir = $(datadir)/doc/$(PACKAGE)
53 myexeclibdir = $(pkglibdir)
54
55 # Delete output file if an error occurred while building it
56 .DELETE_ON_ERROR:
57
58 HS_DIRS = \
59         src \
60         src/Ganeti \
61         src/Ganeti/Block \
62         src/Ganeti/Block/Drbd \
63         src/Ganeti/Confd \
64         src/Ganeti/DataCollectors \
65         src/Ganeti/HTools \
66         src/Ganeti/HTools/Backend \
67         src/Ganeti/HTools/Program \
68         src/Ganeti/Query \
69         test/hs \
70         test/hs/Test \
71         test/hs/Test/Ganeti \
72         test/hs/Test/Ganeti/Block \
73         test/hs/Test/Ganeti/Block/Drbd \
74         test/hs/Test/Ganeti/Confd \
75         test/hs/Test/Ganeti/HTools \
76         test/hs/Test/Ganeti/HTools/Backend \
77         test/hs/Test/Ganeti/Query
78
79 DIRS = \
80         $(HS_DIRS) \
81         autotools \
82         daemons \
83         devel \
84         doc \
85         doc/css \
86         doc/examples \
87         doc/examples/gnt-debug \
88         doc/examples/hooks \
89         test/data/htools \
90         test/data/htools/rapi \
91         test/hs/shelltests \
92         lib \
93         lib/build \
94         lib/client \
95         lib/confd \
96         lib/http \
97         lib/hypervisor \
98         lib/impexpd \
99         lib/masterd \
100         lib/rapi \
101         lib/server \
102         lib/tools \
103         lib/utils \
104         lib/watcher \
105         man \
106         qa \
107         test \
108         test/data \
109         test/data/ovfdata \
110         test/data/ovfdata/other \
111         test/py \
112         tools
113
114 ALL_APIDOC_HS_DIRS = \
115         $(APIDOC_HS_DIR) \
116         $(APIDOC_HS_DIR)/Ganeti \
117         $(APIDOC_HS_DIR)/Ganeti/Block \
118         $(APIDOC_HS_DIR)/Ganeti/Block/Drbd \
119         $(APIDOC_HS_DIR)/Ganeti/Confd \
120         $(APIDOC_HS_DIR)/Ganeti/DataCollectors \
121         $(APIDOC_HS_DIR)/Ganeti/HTools \
122         $(APIDOC_HS_DIR)/Ganeti/HTools/Backend \
123         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
124         $(APIDOC_HS_DIR)/Ganeti/Query
125
126 BUILDTIME_DIR_AUTOCREATE = \
127         scripts \
128         $(APIDOC_DIR) \
129         $(ALL_APIDOC_HS_DIRS) \
130         $(APIDOC_PY_DIR) \
131         $(COVERAGE_DIR) \
132         $(COVERAGE_HS_DIR) \
133         $(COVERAGE_PY_DIR) \
134         .hpc
135
136 BUILDTIME_DIRS = \
137         $(BUILDTIME_DIR_AUTOCREATE) \
138         doc/html \
139         doc/man-html
140
141 DIRCHECK_EXCLUDE = \
142         $(BUILDTIME_DIRS) \
143         ganeti-[0-9]*.[0-9]*.[0-9]* \
144         doc/html/_* \
145         doc/man-html/_* \
146         autom4te.cache
147
148 # some helper vars
149 COVERAGE_DIR = doc/coverage
150 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
151 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
152 APIDOC_DIR = doc/api
153 APIDOC_PY_DIR = $(APIDOC_DIR)/py
154 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
155
156 MAINTAINERCLEANFILES = \
157         $(maninput) \
158         doc/install-quick.rst \
159         doc/news.rst \
160         doc/upgrade.rst \
161         vcs-version
162
163 maintainer-clean-local:
164         rm -rf $(BUILDTIME_DIRS)
165
166 CLEANFILES = \
167         $(addsuffix /*.py[co],$(DIRS)) \
168         $(addsuffix /*.hi,$(HS_DIRS)) \
169         $(addsuffix /*.o,$(HS_DIRS)) \
170         $(PYTHON_BOOTSTRAP) \
171         epydoc.conf \
172         $(REPLACE_VARS_SED) \
173         $(SHELL_ENV_INIT) \
174         daemons/daemon-util \
175         daemons/ganeti-cleaner \
176         $(mandocrst) \
177         doc/manpages-enabled.rst \
178         $(BUILT_EXAMPLES) \
179         doc/examples/bash_completion \
180         doc/examples/bash_completion-debug \
181         lib/_generated_rpc.py \
182         $(man_MANS) \
183         $(manhtml) \
184         tools/kvm-ifup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti-master-role.ocf \
230         doc/examples/ganeti-node-role.ocf \
231         doc/examples/gnt-config-backup \
232         doc/examples/hooks/ipsec
233
234 nodist_pkgpython_PYTHON = \
235         $(BUILT_PYTHON_SOURCES)
236
237 noinst_PYTHON = \
238         lib/build/__init__.py \
239         lib/build/shell_example_lexer.py \
240         lib/build/sphinx_ext.py
241
242 pkgpython_PYTHON = \
243         lib/__init__.py \
244         lib/asyncnotifier.py \
245         lib/backend.py \
246         lib/bdev.py \
247         lib/bootstrap.py \
248         lib/cli.py \
249         lib/cmdlib.py \
250         lib/compat.py \
251         lib/config.py \
252         lib/constants.py \
253         lib/daemon.py \
254         lib/errors.py \
255         lib/ht.py \
256         lib/jqueue.py \
257         lib/jstore.py \
258         lib/locking.py \
259         lib/luxi.py \
260         lib/mcpu.py \
261         lib/netutils.py \
262         lib/objects.py \
263         lib/objectutils.py \
264         lib/opcodes.py \
265         lib/ovf.py \
266         lib/pathutils.py \
267         lib/qlang.py \
268         lib/query.py \
269         lib/rpc.py \
270         lib/rpc_defs.py \
271         lib/runtime.py \
272         lib/serializer.py \
273         lib/ssconf.py \
274         lib/ssh.py \
275         lib/storage.py \
276         lib/uidpool.py \
277         lib/vcluster.py \
278         lib/network.py \
279         lib/workerpool.py
280
281 client_PYTHON = \
282         lib/client/__init__.py \
283         lib/client/gnt_backup.py \
284         lib/client/gnt_cluster.py \
285         lib/client/gnt_debug.py \
286         lib/client/gnt_group.py \
287         lib/client/gnt_instance.py \
288         lib/client/gnt_job.py \
289         lib/client/gnt_node.py \
290         lib/client/gnt_network.py \
291         lib/client/gnt_os.py \
292         lib/client/gnt_storage.py
293
294 hypervisor_PYTHON = \
295         lib/hypervisor/__init__.py \
296         lib/hypervisor/hv_base.py \
297         lib/hypervisor/hv_chroot.py \
298         lib/hypervisor/hv_fake.py \
299         lib/hypervisor/hv_kvm.py \
300         lib/hypervisor/hv_lxc.py \
301         lib/hypervisor/hv_xen.py
302
303 rapi_PYTHON = \
304         lib/rapi/__init__.py \
305         lib/rapi/baserlib.py \
306         lib/rapi/client.py \
307         lib/rapi/client_utils.py \
308         lib/rapi/connector.py \
309         lib/rapi/rlib2.py \
310         lib/rapi/testutils.py
311
312 http_PYTHON = \
313         lib/http/__init__.py \
314         lib/http/auth.py \
315         lib/http/client.py \
316         lib/http/server.py
317
318 confd_PYTHON = \
319         lib/confd/__init__.py \
320         lib/confd/client.py
321
322 masterd_PYTHON = \
323         lib/masterd/__init__.py \
324         lib/masterd/iallocator.py \
325         lib/masterd/instance.py
326
327 impexpd_PYTHON = \
328         lib/impexpd/__init__.py
329
330 watcher_PYTHON = \
331         lib/watcher/__init__.py \
332         lib/watcher/nodemaint.py \
333         lib/watcher/state.py
334
335 server_PYTHON = \
336         lib/server/__init__.py \
337         lib/server/masterd.py \
338         lib/server/noded.py \
339         lib/server/rapi.py
340
341 pytools_PYTHON = \
342         lib/tools/__init__.py \
343         lib/tools/burnin.py \
344         lib/tools/ensure_dirs.py \
345         lib/tools/node_cleanup.py \
346         lib/tools/node_daemon_setup.py \
347         lib/tools/prepare_node_join.py
348
349 utils_PYTHON = \
350         lib/utils/__init__.py \
351         lib/utils/algo.py \
352         lib/utils/filelock.py \
353         lib/utils/hash.py \
354         lib/utils/io.py \
355         lib/utils/log.py \
356         lib/utils/lvm.py \
357         lib/utils/mlock.py \
358         lib/utils/nodesetup.py \
359         lib/utils/process.py \
360         lib/utils/retry.py \
361         lib/utils/text.py \
362         lib/utils/wrapper.py \
363         lib/utils/x509.py
364
365 docinput = \
366         doc/conf.py \
367         doc/css/style.css \
368         doc/admin.rst \
369         doc/cluster-merge.rst \
370         doc/design-2.0.rst \
371         doc/design-2.1.rst \
372         doc/design-2.2.rst \
373         doc/design-2.3.rst \
374         doc/design-2.4.rst \
375         doc/design-2.5.rst \
376         doc/design-2.6.rst \
377         doc/design-2.7.rst \
378         doc/design-autorepair.rst \
379         doc/design-bulk-create.rst \
380         doc/design-chained-jobs.rst \
381         doc/design-cpu-pinning.rst \
382         doc/design-draft.rst \
383         doc/design-htools-2.3.rst \
384         doc/design-http-server.rst \
385         doc/design-impexp2.rst \
386         doc/design-lu-generated-jobs.rst \
387         doc/design-linuxha.rst \
388         doc/design-multi-reloc.rst \
389         doc/design-network.rst \
390         doc/design-node-add.rst \
391         doc/design-oob.rst \
392         doc/design-ovf-support.rst \
393         doc/design-opportunistic-locking.rst \
394         doc/design-partitioned.rst \
395         doc/design-query-splitting.rst \
396         doc/design-query2.rst \
397         doc/design-remote-commands.rst \
398         doc/design-resource-model.rst \
399         doc/design-shared-storage.rst \
400         doc/design-monitoring-agent.rst \
401         doc/design-virtual-clusters.rst \
402         doc/design-x509-ca.rst \
403         doc/design-hroller.rst \
404         doc/devnotes.rst \
405         doc/glossary.rst \
406         doc/hooks.rst \
407         doc/iallocator.rst \
408         doc/index.rst \
409         doc/install-quick.rst \
410         doc/install.rst \
411         doc/locking.rst \
412         doc/manpages-disabled.rst \
413         doc/move-instance.rst \
414         doc/news.rst \
415         doc/ovfconverter.rst \
416         doc/rapi.rst \
417         doc/security.rst \
418         doc/upgrade.rst \
419         doc/virtual-cluster.rst \
420         doc/walkthrough.rst
421
422 # Generates file names such as "doc/man-gnt-instance.rst"
423 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
424
425 # Haskell programs to be installed in $PREFIX/bin
426 HS_BIN_PROGS=src/htools
427
428 # Haskell programs to be installed in the MYEXECLIB dir
429 HS_MYEXECLIB_PROGS=src/mon-collector
430
431 # Haskell programs to compiled but not installed automatically
432 # Usually they have their own specific installation rules
433 HS_COMPILE_PROGS= \
434         src/hconfd \
435         src/rpc-test
436
437 # All Haskell non-test programs to be compiled but not automatically installed
438 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
439
440 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
441 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
442
443 HS_ALL_PROGS = \
444         $(HS_PROGS) \
445         test/hs/hpc-htools \
446         test/hs/hpc-mon-collector \
447         test/hs/htest \
448         $(HS_COMPILE_PROGS)
449
450 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
451 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
452
453 HFLAGS = \
454         -O -Wall -Werror -isrc \
455         -fwarn-monomorphism-restriction \
456         -fwarn-tabs \
457         $(GHC_BYVERSION_FLAGS)
458
459 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
460 HEXTRA =
461 # internal extra flags (used for test/hs/htest mainly)
462 HEXTRA_INT =
463 # exclude options for coverage reports
464 HPCEXCL = --exclude Main \
465         --exclude Ganeti.Constants \
466         --exclude Ganeti.HTools.QC \
467         --exclude Ganeti.THH \
468         --exclude Ganeti.Version \
469         --exclude Test.Ganeti.Attoparsec \
470         --exclude Test.Ganeti.TestCommon \
471         --exclude Test.Ganeti.TestHTools \
472         --exclude Test.Ganeti.TestHelper \
473         --exclude Test.Ganeti.TestImports \
474         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
475
476 HS_LIB_SRCS = \
477         src/Ganeti/Block/Drbd/Types.hs \
478         src/Ganeti/Block/Drbd/Parser.hs \
479         src/Ganeti/BasicTypes.hs \
480         src/Ganeti/Common.hs \
481         src/Ganeti/Compat.hs \
482         src/Ganeti/Confd/Client.hs \
483         src/Ganeti/Confd/Server.hs \
484         src/Ganeti/Confd/Types.hs \
485         src/Ganeti/Confd/Utils.hs \
486         src/Ganeti/Config.hs \
487         src/Ganeti/Daemon.hs \
488         src/Ganeti/DataCollectors/CLI.hs \
489         src/Ganeti/DataCollectors/Drbd.hs \
490         src/Ganeti/DataCollectors/Program.hs \
491         src/Ganeti/DataCollectors/Types.hs \
492         src/Ganeti/Errors.hs \
493         src/Ganeti/HTools/Backend/IAlloc.hs \
494         src/Ganeti/HTools/Backend/Luxi.hs \
495         src/Ganeti/HTools/Backend/Rapi.hs \
496         src/Ganeti/HTools/Backend/Simu.hs \
497         src/Ganeti/HTools/Backend/Text.hs \
498         src/Ganeti/HTools/CLI.hs \
499         src/Ganeti/HTools/Cluster.hs \
500         src/Ganeti/HTools/Container.hs \
501         src/Ganeti/HTools/ExtLoader.hs \
502         src/Ganeti/HTools/Graph.hs \
503         src/Ganeti/HTools/Group.hs \
504         src/Ganeti/HTools/Instance.hs \
505         src/Ganeti/HTools/Loader.hs \
506         src/Ganeti/HTools/Node.hs \
507         src/Ganeti/HTools/PeerMap.hs \
508         src/Ganeti/HTools/Program/Hail.hs \
509         src/Ganeti/HTools/Program/Harep.hs \
510         src/Ganeti/HTools/Program/Hbal.hs \
511         src/Ganeti/HTools/Program/Hcheck.hs \
512         src/Ganeti/HTools/Program/Hinfo.hs \
513         src/Ganeti/HTools/Program/Hscan.hs \
514         src/Ganeti/HTools/Program/Hspace.hs \
515         src/Ganeti/HTools/Program/Hroller.hs \
516         src/Ganeti/HTools/Program/Main.hs \
517         src/Ganeti/HTools/Types.hs \
518         src/Ganeti/Hash.hs \
519         src/Ganeti/JQueue.hs \
520         src/Ganeti/JSON.hs \
521         src/Ganeti/Jobs.hs \
522         src/Ganeti/Logging.hs \
523         src/Ganeti/Luxi.hs \
524         src/Ganeti/Network.hs \
525         src/Ganeti/Objects.hs \
526         src/Ganeti/OpCodes.hs \
527         src/Ganeti/OpParams.hs \
528         src/Ganeti/Path.hs \
529         src/Ganeti/Query/Common.hs \
530         src/Ganeti/Query/Filter.hs \
531         src/Ganeti/Query/Group.hs \
532         src/Ganeti/Query/Job.hs \
533         src/Ganeti/Query/Language.hs \
534         src/Ganeti/Query/Network.hs \
535         src/Ganeti/Query/Node.hs \
536         src/Ganeti/Query/Query.hs \
537         src/Ganeti/Query/Server.hs \
538         src/Ganeti/Query/Types.hs \
539         src/Ganeti/Rpc.hs \
540         src/Ganeti/Runtime.hs \
541         src/Ganeti/Ssconf.hs \
542         src/Ganeti/THH.hs \
543         src/Ganeti/Types.hs \
544         src/Ganeti/Utils.hs
545
546 HS_TEST_SRCS = \
547         test/hs/Test/Ganeti/Attoparsec.hs \
548         test/hs/Test/Ganeti/BasicTypes.hs \
549         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
550         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
551         test/hs/Test/Ganeti/Common.hs \
552         test/hs/Test/Ganeti/Confd/Types.hs \
553         test/hs/Test/Ganeti/Confd/Utils.hs \
554         test/hs/Test/Ganeti/Daemon.hs \
555         test/hs/Test/Ganeti/Errors.hs \
556         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
557         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
558         test/hs/Test/Ganeti/HTools/CLI.hs \
559         test/hs/Test/Ganeti/HTools/Cluster.hs \
560         test/hs/Test/Ganeti/HTools/Container.hs \
561         test/hs/Test/Ganeti/HTools/Graph.hs \
562         test/hs/Test/Ganeti/HTools/Instance.hs \
563         test/hs/Test/Ganeti/HTools/Loader.hs \
564         test/hs/Test/Ganeti/HTools/Node.hs \
565         test/hs/Test/Ganeti/HTools/PeerMap.hs \
566         test/hs/Test/Ganeti/HTools/Types.hs \
567         test/hs/Test/Ganeti/JSON.hs \
568         test/hs/Test/Ganeti/Jobs.hs \
569         test/hs/Test/Ganeti/JQueue.hs \
570         test/hs/Test/Ganeti/Luxi.hs \
571         test/hs/Test/Ganeti/Network.hs \
572         test/hs/Test/Ganeti/Objects.hs \
573         test/hs/Test/Ganeti/OpCodes.hs \
574         test/hs/Test/Ganeti/Query/Filter.hs \
575         test/hs/Test/Ganeti/Query/Language.hs \
576         test/hs/Test/Ganeti/Query/Query.hs \
577         test/hs/Test/Ganeti/Rpc.hs \
578         test/hs/Test/Ganeti/Runtime.hs \
579         test/hs/Test/Ganeti/Ssconf.hs \
580         test/hs/Test/Ganeti/THH.hs \
581         test/hs/Test/Ganeti/TestCommon.hs \
582         test/hs/Test/Ganeti/TestHTools.hs \
583         test/hs/Test/Ganeti/TestHelper.hs \
584         test/hs/Test/Ganeti/Types.hs \
585         test/hs/Test/Ganeti/Utils.hs
586
587 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
588
589 HS_BUILT_SRCS = \
590         test/hs/Test/Ganeti/TestImports.hs \
591         src/Ganeti/Constants.hs \
592         src/Ganeti/Version.hs
593 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
594
595 $(RUN_IN_TEMPDIR): | stamp-directories
596
597 doc/html/index.html: ENABLE_MANPAGES =
598 doc/man-html/index.html: ENABLE_MANPAGES = 1
599 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
600
601 # Note: we use here an order-only prerequisite, as the contents of
602 # _autoconf.py are not actually influencing the html build output: it
603 # has to exist in order for the sphinx module to be loaded
604 # successfully, but we certainly don't want the docs to be rebuilt if
605 # it changes
606 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
607         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
608         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
609         doc/css/style.css \
610         | $(BUILT_PYTHON_SOURCES)
611         @test -n "$(SPHINX)" || \
612             { echo 'sphinx-build' not found during configure; exit 1; }
613 if !MANPAGES_IN_DOC
614         if test -n '$(ENABLE_MANPAGES)'; then \
615           echo 'Man pages in documentation were disabled at configure time' >&2; \
616           exit 1; \
617         fi
618 endif
619 ## Sphinx provides little control over what content should be included. Some
620 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
621 ## build two different versions of the documentation--once without man pages and
622 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
623 ## us with this, but requires running in a temporary directory. It moves the
624 ## correct files into place depending on environment variables.
625         dir=$(dir $@) && \
626         @mkdir_p@ $$dir && \
627         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
628         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
629             -d . \
630             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
631             -D release="$(PACKAGE_VERSION)" \
632             -D graphviz_dot="$(DOT)" \
633             -D enable_manpages="$(ENABLE_MANPAGES)" \
634             doc $(CURDIR)/$$dir && \
635         rm -f $$dir/.buildinfo $$dir/objects.inv
636         touch $@
637
638 doc/html: doc/html/index.html
639
640 doc/man-html: doc/man-html/index.html
641
642 doc/install-quick.rst: INSTALL
643 doc/news.rst: NEWS
644 doc/upgrade.rst: UPGRADE
645
646 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
647         set -e; \
648         { echo '.. This file is automatically updated at build time from $<.'; \
649           echo '.. Do not edit.'; \
650           echo; \
651           cat $<; \
652         } > $@
653
654 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
655         { echo '.. This file is automatically generated, do not edit!'; \
656           echo ''; \
657           echo 'Man pages'; \
658           echo '========='; \
659           echo; \
660           echo '.. toctree::'; \
661           echo '   :maxdepth: 1'; \
662           echo; \
663           for i in $(notdir $(mandocrst)); do \
664             echo "   $$i"; \
665           done | LC_ALL=C sort; \
666         } > $@
667
668 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
669 if MANPAGES_IN_DOC
670         { echo '.. This file is automatically updated at build time from $<.'; \
671           echo '.. Do not edit.'; \
672           echo; \
673           echo "$*"; \
674           echo '=========================================='; \
675           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
676         } > $@
677 else
678         echo 'Man pages in documentation were disabled at configure time' >&2; \
679         exit 1;
680 endif
681
682 # Things to build but not to install (add it to EXTRA_DIST if it should be
683 # distributed)
684 noinst_DATA = \
685         doc/html \
686         $(BUILT_EXAMPLES) \
687         doc/examples/bash_completion \
688         doc/examples/bash_completion-debug \
689         $(manhtml)
690
691 if MANPAGES_IN_DOC
692 noinst_DATA += doc/man-html
693 endif
694
695 gnt_scripts = \
696         scripts/gnt-backup \
697         scripts/gnt-cluster \
698         scripts/gnt-debug \
699         scripts/gnt-group \
700         scripts/gnt-instance \
701         scripts/gnt-job \
702         scripts/gnt-network \
703         scripts/gnt-node \
704         scripts/gnt-os \
705         scripts/gnt-storage
706
707 PYTHON_BOOTSTRAP_SBIN = \
708         daemons/ganeti-masterd \
709         daemons/ganeti-noded \
710         daemons/ganeti-rapi \
711         daemons/ganeti-watcher \
712         $(gnt_scripts)
713
714 PYTHON_BOOTSTRAP = \
715         $(PYTHON_BOOTSTRAP_SBIN) \
716         tools/burnin \
717         tools/ensure-dirs \
718         tools/node-cleanup \
719         tools/node-daemon-setup \
720         tools/prepare-node-join
721
722 qa_scripts = \
723         qa/__init__.py \
724         qa/ganeti-qa.py \
725         qa/qa_cluster.py \
726         qa/qa_config.py \
727         qa/qa_daemon.py \
728         qa/qa_env.py \
729         qa/qa_error.py \
730         qa/qa_group.py \
731         qa/qa_instance.py \
732         qa/qa_job.py \
733         qa/qa_node.py \
734         qa/qa_os.py \
735         qa/qa_rapi.py \
736         qa/qa_tags.py \
737         qa/qa_utils.py
738
739 bin_SCRIPTS =
740 if WANT_HTOOLS
741 bin_SCRIPTS += $(HS_BIN_PROGS)
742 install-exec-hook:
743         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
744 # FIXME: this is a hardcoded logic, instead of auto-resolving
745         $(LN_S) -f ../../../bin/htools \
746           $(DESTDIR)$(iallocatorsdir)/hail
747         for role in $(HS_BIN_ROLES); do \
748           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
749         done
750 endif
751
752 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS) Makefile
753         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
754           echo "Error: cannot run unittests without the development" \
755                " libraries (see devnotes.rst)" 1>&2; \
756           exit 1; \
757         fi
758         @rm -f $(notdir $@).tix
759         $(GHC) --make \
760           $(HFLAGS) \
761           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
762           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
763           $(HEXTRA) $(HEXTRA_INT) $@
764         @touch "$@"
765
766 # for the test/hs/htest binary, we need to enable profiling/coverage
767 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
768
769 # we compile the hpc-htools binary with the program coverage
770 test/hs/hpc-htools: HEXTRA_INT=-fhpc
771
772 # we compile the hpc-mon-collector binary with the program coverage
773 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
774
775 # test dependency
776 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
777
778 # rules for building profiling-enabled versions of the haskell
779 # programs: hs-prof does the full two-step build, whereas
780 # hs-prof-quick does only the final rebuild (hs-prof must have been
781 # run before)
782 .PHONY: hs-prof hs-prof-quick
783 hs-prof:
784         @if [ -z "$(TARGET)" ]; then \
785           echo "You need to define TARGET when running this rule" 1>&2; \
786           exit 1; \
787         fi
788         $(MAKE) $(AM_MAKEFLAGS) clean
789         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
790         rm -f $(HS_ALL_PROGS)
791         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
792
793 hs-prof-quick:
794         @if [ -z "$(TARGET)" ]; then \
795           echo "You need to define TARGET when running this rule" 1>&2; \
796           exit 1; \
797         fi
798         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
799
800 dist_sbin_SCRIPTS = \
801         tools/ganeti-listrunner
802
803 nodist_sbin_SCRIPTS = \
804         $(PYTHON_BOOTSTRAP_SBIN) \
805         daemons/ganeti-cleaner
806
807 if ENABLE_CONFD
808 src/ganeti-confd: src/hconfd
809         cp -f $< $@
810
811 nodist_sbin_SCRIPTS += src/ganeti-confd
812 endif
813
814 python_scripts = \
815         tools/cfgshell \
816         tools/cfgupgrade \
817         tools/cfgupgrade12 \
818         tools/cluster-merge \
819         tools/confd-client \
820         tools/fmtjson \
821         tools/lvmstrap \
822         tools/move-instance \
823         tools/ovfconverter \
824         tools/sanitize-config
825
826 dist_tools_SCRIPTS = \
827         $(python_scripts) \
828         tools/kvm-console-wrapper \
829         tools/master-ip-setup \
830         tools/xen-console-wrapper
831
832 nodist_tools_python_scripts = \
833         tools/node-cleanup
834
835 nodist_tools_SCRIPTS = \
836         $(nodist_tools_python_scripts) \
837         tools/vcluster-setup
838
839 pkglib_python_scripts = \
840         daemons/import-export \
841         tools/check-cert-expired
842
843 nodist_pkglib_python_scripts = \
844         tools/burnin \
845         tools/ensure-dirs \
846         tools/node-daemon-setup \
847         tools/prepare-node-join
848
849 myexeclib_SCRIPTS = \
850         daemons/daemon-util \
851         tools/kvm-ifup \
852         $(pkglib_python_scripts) \
853         $(HS_MYEXECLIB_PROGS)
854
855 nodist_myexeclib_SCRIPTS = \
856         $(nodist_pkglib_python_scripts)
857
858 EXTRA_DIST = \
859         NEWS \
860         UPGRADE \
861         epydoc.conf.in \
862         pylintrc \
863         autotools/build-bash-completion \
864         autotools/build-rpc \
865         autotools/check-header \
866         autotools/check-imports \
867         autotools/check-man-dashes \
868         autotools/check-man-references \
869         autotools/check-man-warnings \
870         autotools/check-news \
871         autotools/check-python-code \
872         autotools/check-tar \
873         autotools/check-version \
874         autotools/convert-constants \
875         autotools/docpp \
876         autotools/gen-py-coverage \
877         autotools/sphinx-wrapper \
878         autotools/testrunner \
879         autotools/wrong-hardcoded-paths \
880         $(RUN_IN_TEMPDIR) \
881         daemons/daemon-util.in \
882         daemons/ganeti-cleaner.in \
883         $(pkglib_python_scripts) \
884         devel/upload \
885         devel/webserver \
886         tools/kvm-ifup.in \
887         tools/vcluster-setup.in \
888         $(docinput) \
889         doc/html \
890         $(BUILT_EXAMPLES:%=%.in) \
891         doc/examples/ganeti.default \
892         doc/examples/ganeti.default-debug \
893         doc/examples/hooks/ethers \
894         doc/examples/gnt-debug/README \
895         doc/examples/gnt-debug/delay0.json \
896         doc/examples/gnt-debug/delay50.json \
897         test/py/lockperf.py \
898         test/py/testutils.py \
899         test/py/mocks.py \
900         $(dist_TESTS) \
901         $(TEST_FILES) \
902         man/footer.rst \
903         $(manrst) \
904         $(maninput) \
905         qa/qa-sample.json \
906         $(qa_scripts) \
907         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
908         $(HS_PROG_SRCS) \
909         src/lint-hints.hs \
910         test/hs/cli-tests-defs.sh \
911         test/hs/offline-test.sh \
912         .ghci
913
914 man_MANS = \
915         man/ganeti-cleaner.8 \
916         man/ganeti-confd.8 \
917         man/ganeti-listrunner.8 \
918         man/ganeti-masterd.8 \
919         man/ganeti-noded.8 \
920         man/ganeti-os-interface.7 \
921         man/ganeti-extstorage-interface.7 \
922         man/ganeti-rapi.8 \
923         man/ganeti-watcher.8 \
924         man/ganeti.7 \
925         man/gnt-backup.8 \
926         man/gnt-cluster.8 \
927         man/gnt-debug.8 \
928         man/gnt-group.8 \
929         man/gnt-network.8 \
930         man/gnt-instance.8 \
931         man/gnt-job.8 \
932         man/gnt-node.8 \
933         man/gnt-os.8 \
934         man/gnt-storage.8 \
935         man/hail.1 \
936         man/hbal.1 \
937         man/hcheck.1 \
938         man/hinfo.1 \
939         man/hscan.1 \
940         man/hspace.1 \
941         man/hroller.1 \
942         man/htools.1 \
943         man/mon-collector.7
944
945 # Remove extensions from all filenames in man_MANS
946 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
947
948 manrst = $(patsubst %,%.rst,$(mannoext))
949 manhtml = $(patsubst %.rst,%.html,$(manrst))
950 mangen = $(patsubst %.rst,%.gen,$(manrst))
951 maninput = \
952         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
953         $(patsubst %.html,%.html.in,$(manhtml)) \
954         $(mangen)
955
956 TEST_FILES = \
957         test/data/htools/clean-nonzero-score.data \
958         test/data/htools/common-suffix.data \
959         test/data/htools/empty-cluster.data \
960         test/data/htools/hail-alloc-drbd.json \
961         test/data/htools/hail-change-group.json \
962         test/data/htools/hail-invalid-reloc.json \
963         test/data/htools/hail-node-evac.json \
964         test/data/htools/hail-reloc-drbd.json \
965         test/data/htools/hbal-excl-tags.data \
966         test/data/htools/hbal-split-insts.data \
967         test/data/htools/invalid-node.data \
968         test/data/htools/missing-resources.data \
969         test/data/htools/n1-failure.data \
970         test/data/htools/rapi/groups.json \
971         test/data/htools/rapi/info.json \
972         test/data/htools/rapi/instances.json \
973         test/data/htools/rapi/nodes.json \
974         test/hs/shelltests/htools-balancing.test \
975         test/hs/shelltests/htools-basic.test \
976         test/hs/shelltests/htools-dynutil.test \
977         test/hs/shelltests/htools-excl.test \
978         test/hs/shelltests/htools-hail.test \
979         test/hs/shelltests/htools-hspace.test \
980         test/hs/shelltests/htools-invalid.test \
981         test/hs/shelltests/htools-multi-group.test \
982         test/hs/shelltests/htools-no-backend.test \
983         test/hs/shelltests/htools-rapi.test \
984         test/hs/shelltests/htools-single-group.test \
985         test/hs/shelltests/htools-text-backend.test \
986         test/hs/shelltests/htools-mon-collector.test \
987         test/data/bdev-drbd-8.0.txt \
988         test/data/bdev-drbd-8.3.txt \
989         test/data/bdev-drbd-disk.txt \
990         test/data/bdev-drbd-net-ip4.txt \
991         test/data/bdev-drbd-net-ip6.txt \
992         test/data/cert1.pem \
993         test/data/cert2.pem \
994         test/data/instance-minor-pairing.txt \
995         test/data/ip-addr-show-dummy0.txt \
996         test/data/ip-addr-show-lo-ipv4.txt \
997         test/data/ip-addr-show-lo-ipv6.txt \
998         test/data/ip-addr-show-lo-oneline-ipv4.txt \
999         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1000         test/data/ip-addr-show-lo-oneline.txt \
1001         test/data/ip-addr-show-lo.txt \
1002         test/data/kvm_0.12.5_help.txt \
1003         test/data/kvm_0.15.90_help.txt \
1004         test/data/kvm_0.9.1_help.txt \
1005         test/data/kvm_0.9.1_help_boot_test.txt \
1006         test/data/kvm_1.0_help.txt \
1007         test/data/kvm_1.1.2_help.txt \
1008         test/data/ovfdata/compr_disk.vmdk.gz \
1009         test/data/ovfdata/config.ini \
1010         test/data/ovfdata/corrupted_resources.ovf \
1011         test/data/ovfdata/empty.ini \
1012         test/data/ovfdata/empty.ovf \
1013         test/data/ovfdata/ganeti.mf \
1014         test/data/ovfdata/ganeti.ovf \
1015         test/data/ovfdata/gzip_disk.ovf \
1016         test/data/ovfdata/new_disk.vmdk \
1017         test/data/ovfdata/no_disk.ini \
1018         test/data/ovfdata/no_disk_in_ref.ovf \
1019         test/data/ovfdata/no_os.ini \
1020         test/data/ovfdata/no_ovf.ova \
1021         test/data/ovfdata/other/rawdisk.raw \
1022         test/data/ovfdata/ova.ova \
1023         test/data/ovfdata/rawdisk.raw \
1024         test/data/ovfdata/second_disk.vmdk \
1025         test/data/ovfdata/unsafe_path.ini \
1026         test/data/ovfdata/virtualbox.ovf \
1027         test/data/ovfdata/wrong_config.ini \
1028         test/data/ovfdata/wrong_extension.ovd \
1029         test/data/ovfdata/wrong_manifest.mf \
1030         test/data/ovfdata/wrong_manifest.ovf \
1031         test/data/ovfdata/wrong_ova.ova \
1032         test/data/ovfdata/wrong_xml.ovf \
1033         test/data/proc_drbd8.txt \
1034         test/data/proc_drbd80-emptyline.txt \
1035         test/data/proc_drbd83.txt \
1036         test/data/proc_drbd83_sync.txt \
1037         test/data/proc_drbd83_sync_want.txt \
1038         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1039         test/data/qa-minimal-nodes-instances-only.json \
1040         test/data/sys_drbd_usermode_helper.txt \
1041         test/data/vgreduce-removemissing-2.02.02.txt \
1042         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1043         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1044         test/data/vgs-missing-pvs-2.02.02.txt \
1045         test/data/vgs-missing-pvs-2.02.66.txt \
1046         test/data/xen-xm-info-4.0.1.txt \
1047         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1048         test/data/xen-xm-list-4.0.1-four-instances.txt \
1049         test/py/ganeti-cli.test \
1050         test/py/gnt-cli.test \
1051         test/py/import-export_unittest-helper
1052
1053 python_tests = \
1054         doc/examples/rapi_testutils.py \
1055         test/py/cfgupgrade_unittest.py \
1056         test/py/docs_unittest.py \
1057         test/py/ganeti.asyncnotifier_unittest.py \
1058         test/py/ganeti.backend_unittest-runasroot.py \
1059         test/py/ganeti.backend_unittest.py \
1060         test/py/ganeti.bdev_unittest.py \
1061         test/py/ganeti.cli_unittest.py \
1062         test/py/ganeti.client.gnt_cluster_unittest.py \
1063         test/py/ganeti.client.gnt_instance_unittest.py \
1064         test/py/ganeti.client.gnt_job_unittest.py \
1065         test/py/ganeti.cmdlib_unittest.py \
1066         test/py/ganeti.compat_unittest.py \
1067         test/py/ganeti.confd.client_unittest.py \
1068         test/py/ganeti.config_unittest.py \
1069         test/py/ganeti.constants_unittest.py \
1070         test/py/ganeti.daemon_unittest.py \
1071         test/py/ganeti.errors_unittest.py \
1072         test/py/ganeti.hooks_unittest.py \
1073         test/py/ganeti.ht_unittest.py \
1074         test/py/ganeti.http_unittest.py \
1075         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1076         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1077         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1078         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1079         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1080         test/py/ganeti.hypervisor_unittest.py \
1081         test/py/ganeti.impexpd_unittest.py \
1082         test/py/ganeti.jqueue_unittest.py \
1083         test/py/ganeti.jstore_unittest.py \
1084         test/py/ganeti.locking_unittest.py \
1085         test/py/ganeti.luxi_unittest.py \
1086         test/py/ganeti.masterd.iallocator_unittest.py \
1087         test/py/ganeti.masterd.instance_unittest.py \
1088         test/py/ganeti.mcpu_unittest.py \
1089         test/py/ganeti.netutils_unittest.py \
1090         test/py/ganeti.objects_unittest.py \
1091         test/py/ganeti.objectutils_unittest.py \
1092         test/py/ganeti.opcodes_unittest.py \
1093         test/py/ganeti.ovf_unittest.py \
1094         test/py/ganeti.qlang_unittest.py \
1095         test/py/ganeti.query_unittest.py \
1096         test/py/ganeti.rapi.baserlib_unittest.py \
1097         test/py/ganeti.rapi.client_unittest.py \
1098         test/py/ganeti.rapi.resources_unittest.py \
1099         test/py/ganeti.rapi.rlib2_unittest.py \
1100         test/py/ganeti.rapi.testutils_unittest.py \
1101         test/py/ganeti.rpc_unittest.py \
1102         test/py/ganeti.runtime_unittest.py \
1103         test/py/ganeti.serializer_unittest.py \
1104         test/py/ganeti.server.rapi_unittest.py \
1105         test/py/ganeti.ssconf_unittest.py \
1106         test/py/ganeti.ssh_unittest.py \
1107         test/py/ganeti.storage_unittest.py \
1108         test/py/ganeti.tools.burnin_unittest.py \
1109         test/py/ganeti.tools.ensure_dirs_unittest.py \
1110         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1111         test/py/ganeti.tools.prepare_node_join_unittest.py \
1112         test/py/ganeti.uidpool_unittest.py \
1113         test/py/ganeti.utils.algo_unittest.py \
1114         test/py/ganeti.utils.filelock_unittest.py \
1115         test/py/ganeti.utils.hash_unittest.py \
1116         test/py/ganeti.utils.io_unittest-runasroot.py \
1117         test/py/ganeti.utils.io_unittest.py \
1118         test/py/ganeti.utils.log_unittest.py \
1119         test/py/ganeti.utils.lvm_unittest.py \
1120         test/py/ganeti.utils.mlock_unittest.py \
1121         test/py/ganeti.utils.nodesetup_unittest.py \
1122         test/py/ganeti.utils.process_unittest.py \
1123         test/py/ganeti.utils.retry_unittest.py \
1124         test/py/ganeti.utils.text_unittest.py \
1125         test/py/ganeti.utils.wrapper_unittest.py \
1126         test/py/ganeti.utils.x509_unittest.py \
1127         test/py/ganeti.utils_unittest.py \
1128         test/py/ganeti.vcluster_unittest.py \
1129         test/py/ganeti.workerpool_unittest.py \
1130         test/py/pycurl_reset_unittest.py \
1131         test/py/qa.qa_config_unittest.py \
1132         test/py/tempfile_fork_unittest.py
1133
1134 haskell_tests = test/hs/htest
1135
1136 dist_TESTS = \
1137         test/py/check-cert-expired_unittest.bash \
1138         test/py/daemon-util_unittest.bash \
1139         test/py/ganeti-cleaner_unittest.bash \
1140         test/py/import-export_unittest.bash \
1141         test/py/cli-test.bash \
1142         test/py/bash_completion.bash \
1143         $(python_tests)
1144
1145 nodist_TESTS =
1146 check_SCRIPTS =
1147
1148 if WANT_HSTESTS
1149 nodist_TESTS += $(haskell_tests)
1150 dist_TESTS += test/hs/offline-test.sh
1151 check_SCRIPTS += \
1152         test/hs/hpc-htools \
1153         test/hs/hpc-mon-collector \
1154         $(HS_BUILT_TEST_HELPERS)
1155 endif
1156
1157 TESTS = $(dist_TESTS) $(nodist_TESTS)
1158
1159 # Environment for all tests
1160 PLAIN_TESTS_ENVIRONMENT = \
1161         PYTHONPATH=. \
1162         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1163         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1164         $(RUN_IN_TEMPDIR)
1165
1166 # Environment for tests run by automake
1167 TESTS_ENVIRONMENT = \
1168         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1169
1170 all_python_code = \
1171         $(dist_sbin_SCRIPTS) \
1172         $(python_scripts) \
1173         $(pkglib_python_scripts) \
1174         $(nodist_pkglib_python_scripts) \
1175         $(nodist_tools_python_scripts) \
1176         $(python_tests) \
1177         $(pkgpython_PYTHON) \
1178         $(client_PYTHON) \
1179         $(hypervisor_PYTHON) \
1180         $(rapi_PYTHON) \
1181         $(server_PYTHON) \
1182         $(pytools_PYTHON) \
1183         $(http_PYTHON) \
1184         $(confd_PYTHON) \
1185         $(masterd_PYTHON) \
1186         $(impexpd_PYTHON) \
1187         $(utils_PYTHON) \
1188         $(watcher_PYTHON) \
1189         $(noinst_PYTHON) \
1190         $(qa_scripts)
1191
1192 srclink_files = \
1193         man/footer.rst \
1194         test/py/check-cert-expired_unittest.bash \
1195         test/py/daemon-util_unittest.bash \
1196         test/py/ganeti-cleaner_unittest.bash \
1197         test/py/import-export_unittest.bash \
1198         test/py/cli-test.bash \
1199         test/py/bash_completion.bash \
1200         test/hs/offline-test.sh \
1201         test/hs/cli-tests-defs.sh \
1202         $(all_python_code) \
1203         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1204         $(docinput)
1205
1206 check_python_code = \
1207         $(BUILD_BASH_COMPLETION) \
1208         $(CHECK_IMPORTS) \
1209         $(CHECK_HEADER) \
1210         $(DOCPP) \
1211         $(all_python_code)
1212
1213 lint_python_code = \
1214         ganeti \
1215         ganeti/http/server.py \
1216         $(dist_sbin_SCRIPTS) \
1217         $(python_scripts) \
1218         $(pkglib_python_scripts) \
1219         $(BUILD_BASH_COMPLETION) \
1220         $(CHECK_IMPORTS) \
1221         $(CHECK_HEADER) \
1222         $(DOCPP) \
1223         $(PYTHON_BOOTSTRAP)
1224
1225 standalone_python_modules = \
1226         lib/rapi/client.py \
1227         tools/ganeti-listrunner
1228
1229 pep8_python_code = \
1230         ganeti \
1231         ganeti/http/server.py \
1232         $(dist_sbin_SCRIPTS) \
1233         $(python_scripts) \
1234         $(pkglib_python_scripts) \
1235         $(BUILD_BASH_COMPLETION) \
1236         $(CHECK_HEADER) \
1237         $(DOCPP) \
1238         $(PYTHON_BOOTSTRAP) \
1239         qa
1240
1241 test/py/daemon-util_unittest.bash: daemons/daemon-util
1242
1243 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1244
1245 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1246
1247 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1248         sed -f $(REPLACE_VARS_SED) < $< > $@
1249         chmod +x $@
1250
1251 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1252         sed -f $(REPLACE_VARS_SED) < $< > $@
1253         chmod +x $@
1254
1255 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1256         sed -f $(REPLACE_VARS_SED) < $< > $@
1257         chmod +x $@
1258
1259 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1260         sed -f $(REPLACE_VARS_SED) < $< > $@
1261
1262 doc/examples/bash_completion: BC_ARGS = --compact
1263 doc/examples/bash_completion-debug: BC_ARGS =
1264
1265 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1266         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1267         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1268         daemons/ganeti-cleaner \
1269         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1270         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1271           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1272
1273 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1274         lib/build/shell_example_lexer.py \
1275         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1276         @echo "Checking $< for hardcoded paths..."
1277         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1278           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1279           exit 1; \
1280         fi
1281         set -e ; \
1282         trap 'echo auto-removing $@; rm $@' EXIT; \
1283         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1284         $(CHECK_MAN_REFERENCES) $@; \
1285         trap - EXIT
1286
1287 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1288         @test -n "$(PANDOC)" || \
1289           { echo 'pandoc' not found during configure; exit 1; }
1290         set -o pipefail ; \
1291         trap 'echo auto-removing $@; rm $@' EXIT; \
1292         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1293           sed -e 's/\\@/@/g' > $@; \
1294         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1295         $(CHECK_MAN_DASHES) $@; \
1296         trap - EXIT
1297
1298 man/%.html.in: man/%.gen man/footer.rst
1299         @test -n "$(PANDOC)" || \
1300           { echo 'pandoc' not found during configure; exit 1; }
1301         set -o pipefail ; \
1302         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1303           sed -e 's/\\@/@/g' > $@
1304
1305 man/%: man/%.in  $(REPLACE_VARS_SED)
1306         sed -f $(REPLACE_VARS_SED) < $< > $@
1307
1308 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1309         sed -f $(REPLACE_VARS_SED) < $< > $@
1310
1311 vcs-version:
1312         if test -d .git; then \
1313           git describe > $@; \
1314         elif test ! -f $@ ; then \
1315           echo "Cannot auto-generate $@ file"; exit 1; \
1316         fi
1317
1318 .PHONY: clean-vcs-version
1319 clean-vcs-version:
1320         rm -f vcs-version
1321
1322 .PHONY: regen-vcs-version
1323 regen-vcs-version:
1324         @set -e; \
1325         cd $(srcdir); \
1326         if test -d .git; then \
1327           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1328           git describe > $$T; \
1329           if ! cmp --quiet $$T vcs-version; then \
1330             mv $$T vcs-version; \
1331           fi; \
1332         fi
1333
1334 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1335         vcs-version $(built_base_sources)
1336         set -e; \
1337         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1338         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1339
1340 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1341         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1342         lib/jstore.py $(RUN_IN_TEMPDIR) \
1343         $(CONVERT_CONSTANTS) $(built_base_sources) \
1344         | lib/_vcsversion.py
1345         set -e; \
1346         { cat $< ; \
1347           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1348         } > $@
1349
1350 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1351         $(built_base_sources)
1352         set -e; \
1353         { cat $< ; \
1354           echo ; \
1355           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1356             echo "import $$name ()" ; \
1357           done ; \
1358         } > $@
1359
1360 lib/_autoconf.py: Makefile | stamp-directories
1361         set -e; \
1362         { echo '# This file is automatically generated, do not edit!'; \
1363           echo '#'; \
1364           echo ''; \
1365           echo '"""Build-time configuration for Ganeti.'; \
1366           echo '';\
1367           echo 'This file is autogenerated by the build process.'; \
1368           echo 'For any changes you need to re-run ./configure (and'; \
1369           echo 'not edit by hand).'; \
1370           echo ''; \
1371           echo '"""'; \
1372           echo ''; \
1373           echo '# pylint: disable=C0301,C0324'; \
1374           echo '# because this is autogenerated, we do not want'; \
1375           echo '# style warnings' ; \
1376           echo ''; \
1377           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1378           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1379           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1380           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1381           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1382           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1383           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1384           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1385           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1386           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1387           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1388           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1389           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1390           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1391           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1392           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1393           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1394           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1395           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1396           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1397           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1398           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1399           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1400           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1401           echo "KVM_PATH = '$(KVM_PATH)'"; \
1402           echo "IP_PATH = '$(IP_PATH)'"; \
1403           echo "SOCAT_PATH = '$(SOCAT)'"; \
1404           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1405           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1406           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1407           echo "TOOLSDIR = '$(toolsdir)'"; \
1408           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1409           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1410           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1411           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1412           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1413           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1414           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1415           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1416           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1417           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1418           echo "RAPI_USER = '$(RAPI_USER)'"; \
1419           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1420           echo "CONFD_USER = '$(CONFD_USER)'"; \
1421           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1422           echo "NODED_USER = '$(NODED_USER)'"; \
1423           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1424           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1425           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1426           echo "HTOOLS = True"; \
1427           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1428           echo "XEN_CMD = '$(XEN_CMD)'"; \
1429           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1430           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1431           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1432 ## Write dictionary with man page name as the key and the section number as the
1433 ## value
1434           echo "MAN_PAGES = {"; \
1435           for i in $(notdir $(man_MANS)); do \
1436             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1437           done; \
1438           echo "}"; \
1439         } > $@
1440
1441 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1442         set -e; \
1443         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1444         { echo '# This file is automatically generated, do not edit!'; \
1445           echo '#'; \
1446           echo ''; \
1447           echo '"""Build-time VCS version number for Ganeti.'; \
1448           echo '';\
1449           echo 'This file is autogenerated by the build process.'; \
1450           echo 'For any changes you need to re-run ./configure (and'; \
1451           echo 'not edit by hand).'; \
1452           echo ''; \
1453           echo '"""'; \
1454           echo ''; \
1455           echo '# pylint: disable=C0301,C0324'; \
1456           echo '# because this is autogenerated, we do not want'; \
1457           echo '# style warnings' ; \
1458           echo ''; \
1459           echo "VCS_VERSION = '$$VCSVER'"; \
1460         } > $@
1461
1462 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1463         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1464
1465 $(SHELL_ENV_INIT): Makefile stamp-directories
1466         set -e; \
1467         { echo '# Allow overriding for tests'; \
1468           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1469           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1470           echo; \
1471           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1472           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1473           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1474           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1475           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1476         } > $@
1477
1478 ## Writes sed script to replace placeholders with build-time values. The
1479 ## additional quotes after the first @ sign are necessary to stop configure
1480 ## from replacing those values as well.
1481 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1482         set -e; \
1483         { echo 's#@''PREFIX@#$(prefix)#g'; \
1484           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1485           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1486           echo 's#@''BINDIR@#$(bindir)#g'; \
1487           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1488           echo 's#@''LIBDIR@#$(libdir)#g'; \
1489           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1490           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1491           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1492           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1493           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1494           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1495           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1496           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1497           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1498           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1499           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1500           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1501           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1502           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1503           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1504           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1505           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1506           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1507           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1508           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1509           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1510           echo; \
1511           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1512           echo '  r $(SHELL_ENV_INIT)'; \
1513           echo '  d'; \
1514           echo '}'; \
1515         } > $@
1516
1517 # Using deferred evaluation
1518 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1519 daemons/ganeti-watcher: MODULE = ganeti.watcher
1520 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1521 tools/burnin: MODULE = ganeti.tools.burnin
1522 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1523 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1524 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1525 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1526 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1527
1528 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1529         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1530         set -e; \
1531         { echo '#!/usr/bin/python'; \
1532           echo '# This file is automatically generated, do not edit!'; \
1533           echo "# Edit $(MODULE) instead."; \
1534           echo; \
1535           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1536           echo; \
1537           echo '# pylint: disable=C0103'; \
1538           echo '# C0103: Invalid name'; \
1539           echo; \
1540           echo 'import sys'; \
1541           echo 'import $(MODULE) as main'; \
1542           echo; \
1543           echo '# Temporarily alias commands until bash completion'; \
1544           echo '# generator is changed'; \
1545           echo 'if hasattr(main, "commands"):'; \
1546           echo '  commands = main.commands # pylint: disable=E1101'; \
1547           echo 'if hasattr(main, "aliases"):'; \
1548           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1549           echo; \
1550           echo 'if __name__ == "__main__":'; \
1551           echo '  sys.exit(main.Main())'; \
1552         } > $@
1553         chmod u+x $@
1554
1555 $(HS_BUILT_TEST_HELPERS): Makefile
1556         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1557         set -e; \
1558         { echo '#!/bin/sh'; \
1559           echo '# This file is automatically generated, do not edit!'; \
1560           echo "# Edit Makefile.am instead."; \
1561           echo; \
1562           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1563         } > $@
1564         chmod u+x $@
1565
1566 stamp-directories: Makefile
1567         $(MAKE) $(AM_MAKEFLAGS) ganeti
1568         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1569         touch $@
1570
1571 # We need to create symlinks because "make distcheck" will not install Python
1572 # files when building.
1573 stamp-srclinks: Makefile | stamp-directories
1574         set -e; \
1575         for i in $(srclink_files); do \
1576           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1577             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1578           fi; \
1579         done
1580         touch $@
1581
1582 .PHONY: ganeti
1583 ganeti:
1584         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1585
1586 .PHONY: check-dirs
1587 check-dirs: $(GENERATED_FILES)
1588         @set -e; \
1589         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1590           error=; \
1591           while read dir; do \
1592             case "$$dir" in \
1593               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1594               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1595             esac; \
1596           done; \
1597           for dir in $(DIRS); do \
1598             if ! test -d "$$dir"; then \
1599               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1600               error=1; \
1601             fi \
1602           done; \
1603           test -z "$$error"; \
1604         }
1605
1606 .PHONY: check-local
1607 check-local: check-dirs $(GENERATED_FILES)
1608         $(CHECK_PYTHON_CODE) $(check_python_code)
1609         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1610         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1611         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1612         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1613         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1614         error= ; \
1615         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1616           echo "Incorrect version in README, expected $$expver" >&2; \
1617           error=1; \
1618         fi; \
1619         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1620             doc/security.rst; do \
1621           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1622             "Documents Ganeti version $$expver"; then \
1623             echo "Incorrect version in $$file, expected $$expver" >&2; \
1624             error=1; \
1625           fi; \
1626         done; \
1627         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1628           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1629           error=1; \
1630         fi; \
1631         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1632           ".. Last updated for Ganeti $$expver"; then \
1633           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1634           error=1; \
1635         fi; \
1636         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1637           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1638             echo "Longest line in $$file is longer than 80 characters" >&2; \
1639             error=1; \
1640           fi; \
1641         done; \
1642         test -z "$$error"
1643
1644 .PHONY: hs-tests
1645 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1646         @rm -f htest.tix
1647         ./test/hs/htest
1648
1649 .PHONY: hs-shell
1650 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1651         @rm -f hpc-htools.tix hpc-mon-collector.tix
1652         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1653
1654 .PHONY: hs-check
1655 hs-check: hs-tests hs-shell
1656
1657 # E111: indentation is not a multiple of four
1658 # E121: continuation line indentation is not a multiple of four
1659 #       (since our indent level is not 4)
1660 # E125: continuation line does not distinguish itself from next logical line
1661 #       (since our indent level is not 4)
1662 # E127: continuation line over-indented for visual indent
1663 #       (since our indent level is not 4)
1664 # note: do NOT add E128 here; it's a valid style error in most cases!
1665 # I've seen real errors, but also some cases were we indent wrongly
1666 # due to line length; try to rework the cases where it is triggered,
1667 # instead of silencing it
1668 # E261: at least two spaces before inline comment
1669 # E501: line too long (80 characters)
1670 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1671
1672 # For excluding pep8 expects filenames only, not whole paths
1673 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1674
1675 LINT_TARGETS = pylint pylint-qa
1676 if HAS_PEP8
1677 LINT_TARGETS += pep8
1678 endif
1679 if HAS_HLINT
1680 LINT_TARGETS += hlint
1681 endif
1682
1683 .PHONY: lint
1684 lint: $(LINT_TARGETS)
1685
1686 .PHONY: pylint
1687 pylint: $(GENERATED_FILES)
1688         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1689         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1690
1691 .PHONY: pylint-qa
1692 pylint-qa: $(GENERATED_FILES)
1693         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1694         cd $(top_srcdir)/qa && \
1695           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1696           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1697
1698 .PHONY: pep8
1699 pep8: $(GENERATED_FILES)
1700         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1701         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1702           --repeat $(pep8_python_code)
1703
1704 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1705 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1706 .PHONY: hlint
1707 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1708         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1709         @rm -f doc/hs-lint.html
1710         if tty -s; then C="-c"; else C=""; fi; \
1711         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1712           --ignore "Use first" \
1713           --ignore "Use &&&" \
1714           --ignore "Use void" \
1715           --ignore "Reduce duplication" \
1716           --hint src/lint-hints \
1717           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1718         @if [ ! -f doc/hs-lint.html ]; then \
1719           echo "All good" > doc/hs-lint.html; \
1720         fi
1721
1722 # a dist hook rule for updating the vcs-version file; this is
1723 # hardcoded due to where it needs to build the file...
1724 dist-hook:
1725         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1726         rm -f $(top_distdir)/vcs-version
1727         cp -p $(srcdir)/vcs-version $(top_distdir)
1728
1729 # a distcheck hook rule for catching revision control directories
1730 distcheck-hook:
1731         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1732           echo "Found revision control files in final archive." 1>&2; \
1733           exit 1; \
1734         fi
1735         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1736           echo "Found Python byte code in final archive." 1>&2; \
1737           exit 1; \
1738         fi
1739         if find $(top_distdir) -name '*~' | grep .; then \
1740           echo "Found backup files in final archive." 1>&2; \
1741           exit 1; \
1742         fi
1743 # Empty files or directories should not be distributed. They can cause
1744 # unnecessary warnings for packagers. Directories used by automake during
1745 # distcheck must be excluded.
1746         if find $(top_distdir) -empty -and -not \( \
1747             -path $(top_distdir)/_build -or \
1748             -path $(top_distdir)/_inst \) | grep .; then \
1749           echo "Found empty files or directories in final archive." 1>&2; \
1750           exit 1; \
1751         fi
1752         if test -n "$(BUILD_RELEASE)" && \
1753            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1754            echo "Found unreleased version in NEWS." >&2; \
1755            exit 1; \
1756         fi
1757         if test -e $(top_distdir)/doc/man-html; then \
1758           echo "Found documentation including man pages in final archive" >&2; \
1759           exit 1; \
1760         fi
1761
1762 # When building a release, stricter checks should be used
1763 distcheck-release dist-release: export BUILD_RELEASE = 1
1764 distcheck-release: distcheck
1765
1766 distrebuildcheck: dist
1767         set -e; \
1768         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1769         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1770         cd $$builddir; \
1771         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1772         cd $(distdir); \
1773         ./configure; \
1774         $(MAKE) maintainer-clean; \
1775         cp $(abs_srcdir)/vcs-version .; \
1776         ./configure; \
1777         $(MAKE) $(AM_MAKEFLAGS)
1778
1779 dist-release: dist
1780         set -e; \
1781         for i in $(DIST_ARCHIVES); do \
1782           echo -n "Checking $$i ... "; \
1783           autotools/check-tar < $$i; \
1784           echo OK; \
1785         done
1786
1787 install-exec-local:
1788         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1789           "$(DESTDIR)${localstatedir}/log/ganeti" \
1790           "$(DESTDIR)${localstatedir}/run/ganeti"
1791
1792 .PHONY: apidoc
1793 if WANT_HSAPIDOC
1794 apidoc: py-apidoc hs-apidoc
1795 else
1796 apidoc: py-apidoc
1797 endif
1798
1799 .PHONY: py-apidoc
1800 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1801         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1802         $(RUN_IN_TEMPDIR) epydoc -v \
1803           --conf $(CURDIR)/epydoc.conf \
1804           --output $(CURDIR)/$(APIDOC_PY_DIR)
1805
1806 .PHONY: hs-apidoc
1807 hs-apidoc: $(HS_BUILT_SRCS)
1808         @test -n "$(HSCOLOUR)" || \
1809             { echo 'HsColour' not found during configure; exit 1; }
1810         @test -n "$(HADDOCK)" || \
1811             { echo 'haddock' not found during configure; exit 1; }
1812         rm -rf $(APIDOC_HS_DIR)/*
1813         for i in $(ALL_APIDOC_HS_DIRS); do \
1814           @mkdir_p@ $$i; \
1815         done
1816         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1817         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1818         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1819         set -e ; \
1820         cd src; \
1821         if [ "$(HS_NOCURL)" ]; \
1822         then OPTGHC="--optghc=$(HS_NOCURL)"; \
1823         else OPTGHC=""; \
1824         fi; \
1825         if [ "$(HS_PARALLEL3)" ]; \
1826         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1827         fi; \
1828         if [ "$(HS_REGEX_PCRE)" ]; \
1829         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1830         fi; \
1831         RELSRCS="$(HS_LIB_SRCS:src/%=%) $(patsubst src/%,%,$(filter src/%,$(HS_BUILT_SRCS)))"; \
1832         for file in $$RELSRCS; do \
1833           hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1834           $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1835         done ; \
1836         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1837           -t ganeti -p haddock-prologue \
1838           --source-module="%{MODULE/.//}.html" \
1839           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1840           $$OPTGHC \
1841           $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:src/%=%))
1842
1843 .PHONY: TAGS
1844 TAGS: $(GENERATED_FILES)
1845         rm -f TAGS
1846         $(GHC) -e ":etags" -v0 \
1847           $(filter-out -O -Werror,$(HFLAGS)) \
1848           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1849           $(HS_LIBTEST_SRCS)
1850         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1851           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1852           -path './qa/*.py' | \
1853           etags -l python -a -
1854
1855 .PHONY: coverage
1856 if WANT_HTOOLS
1857 coverage: py-coverage hs-coverage
1858 else
1859 coverage: py-coverage
1860 endif
1861
1862 .PHONY: py-coverage
1863 py-coverage: $(GENERATED_FILES) $(python_tests)
1864         @test -n "$(PYCOVERAGE)" || \
1865             { echo 'python-coverage' not found during configure; exit 1; }
1866         set -e; \
1867         COVERAGE=$(PYCOVERAGE) \
1868         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1869         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1870         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1871         $(PLAIN_TESTS_ENVIRONMENT) \
1872         $(abs_top_srcdir)/autotools/gen-py-coverage \
1873         $(python_tests)
1874
1875 .PHONY: hs-coverage
1876 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1877         rm -f *.tix
1878         $(MAKE) $(AM_MAKEFLAGS) hs-check
1879         @mkdir_p@ $(COVERAGE_HS_DIR)
1880         hpc sum --union $(HPCEXCL) \
1881           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1882         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1883         hpc report coverage-hs.tix
1884         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1885
1886 # Special "kind-of-QA" target for htools, needs special setup (all
1887 # tools compiled with -fhpc)
1888 .PHONY: live-test
1889 live-test: all
1890         set -e ; \
1891         cd src; \
1892         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1893         rm -f *.tix *.mix; \
1894         ./live-test.sh; \
1895         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1896           --output=live-test.tix ; \
1897         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1898         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1899           --srcdir=.. $(HPCEXCL) ; \
1900         hpc report --srcdir=.. live-test $(HPCEXCL)
1901
1902 commit-check: distcheck lint apidoc
1903
1904 .PHONY: gitignore-check
1905 gitignore-check:
1906         @if [ -n "`git status --short`" ]; then \
1907           echo "Git status is not clean!" 1>&2 ; \
1908           git status --short; \
1909           exit 1; \
1910         fi
1911
1912 # target to rebuild all man pages (both groff and html output)
1913 .PHONY: man
1914 man: $(man_MANS) $(manhtml)
1915
1916 # Target that builds all binaries (including those that are not
1917 # rebuilt except when running the tests)
1918 .PHONY: really-all
1919 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1920
1921 # we don't need the ancient implicit rules:
1922 %: %,v
1923 %: RCS/%,v
1924 %: RCS/%
1925 %: s.%
1926 %: SCCS/s.%
1927
1928 -include ./Makefile.local
1929
1930 # vim: set noet :